POJ1077&HDU1043 Eight 八数码第八境界 IDA* hash 康托展开 奇偶剪枝

7 篇文章 0 订阅
5 篇文章 0 订阅

Description
The 15-puzzle has been around for over 100 years; even if you don't know it by that name, you've seen it. It is constructed with 15 sliding tiles, each with a number from 1 to 15 on it, and all packed into a 4 by 4 frame with one tile missing. Let's call the missing tile 'x'; the object of the puzzle is to arrange the tiles so that they are ordered as: 
 1  2  3  4 

 5  6  7  8 

 9 10 11 12 

13 14 15  x 

where the only legal operation is to exchange 'x' with one of the tiles with which it shares an edge. As an example, the following sequence of moves solves a slightly scrambled puzzle: 
 1  2  3  4    1  2  3  4    1  2  3  4    1  2  3  4 

 5  6  7  8    5  6  7  8    5  6  7  8    5  6  7  8 

 9  x 10 12    9 10  x 12    9 10 11 12    9 10 11 12 

13 14 11 15   13 14 11 15   13 14  x 15   13 14 15  x 

           r->           d->           r-> 

The letters in the previous row indicate which neighbor of the 'x' tile is swapped with the 'x' tile at each step; legal values are 'r','l','u' and 'd', for right, left, up, and down, respectively. 

Not all puzzles can be solved; in 1870, a man named Sam Loyd was famous for distributing an unsolvable version of the puzzle, and 
frustrating many people. In fact, all you have to do to make a regular puzzle into an unsolvable one is to swap two tiles (not counting the missing 'x' tile, of course). 

In this problem, you will write a program for solving the less well-known 8-puzzle, composed of tiles on a three by three 
arrangement. 

Input

You will receive a description of a configuration of the 8 puzzle. The description is just a list of the tiles in their initial positions, with the rows listed from top to bottom, and the tiles listed from left to right within a row, where the tiles are represented by numbers 1 to 8, plus 'x'. For example, this puzzle 
 1  2  3 

 x  4  6 

 7  5  8 

is described by this list: 
 1 2 3 x 4 6 7 5 8 

Output

You will print to standard output either the word ``unsolvable'', if the puzzle has no solution, or a string consisting entirely of the letters 'r', 'l', 'u' and 'd' that describes a series of moves that produce a solution. The string should include no spaces and start at the beginning of the line.

Sample Input

 2  3  4  1  5  x  7  6  8 

Sample Output

ullddrurdllurdruldr

终于把八数码修炼第八境界了,先为自己鼓个爪!

第八境界用到了IDA*,hash,康托展开和逆展开,哈曼顿距离做下界剪枝,奇偶剪枝

不过其实还没有第七境界快,但是第八境界大大节约了内存,而且实现起来比A*容易多了。

#include <cstdio>
#include <cstring>
#include <string>
#include <set>
#include <queue>
#include <algorithm>
#include <map>
#include <stack>
using namespace std;
const int MAXN = 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 + 10;
const int INF = 0x3f3f3f3f;

struct Path {
    int dir;
    int next;
    Path(int dir = 0, int next = 0) {
        this->dir = dir;
        this->next = next;
    }
} path[MAXN];

int jie[10] = {1, 1};
int dirx[] = {-1, 0, 1, 0};
int diry[] = {0, -1, 0, 1};
char dir[] = "uldr";
int minAns;

string Tidy(char* s) {
    int len = strlen(s);
    string ans = "";
    for (int i = 0; i < len; ++i) {
        if (s[i] == 'x') s[i] = '9';
        if (s[i] != ' ') ans += s[i];
    }
    return ans;
}

int IndexOfX(string s) {
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '9') return i;
    }
    return -1;
}

bool InRange(int x, int y) {
    return x >= 0 && x < 3 && y >= 0 && y < 3;
}

int Hash(string s) {
    int ans = 0;
    for (int i = 0; i < 9; ++i) {
        int  rev = 0;
        for (int j = i + 1; j < 9; ++j) {
            if (s[i] > s[j]) ++rev;
        }
        ans += rev * jie[8 - i];
    }
    return ans;
}

string RevHash(int val) {
    string ans = "";
    bool tag[10] = {};
    for (int i = 0; i < 9; ++i) {
        int tNum = val / jie[8 - i] + 1;
        for (int j = 1; j <= tNum; ++j) {
            if (tag[j]) ++tNum;
        }
        val %= jie[8 - i];
        ans += tNum + '0';
        tag[tNum] = true;
    }
    return ans;
}

int H(string s) {
    int h = 0;
    int index = 0;
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            int num = s[index++] - '1';
            if (num == 8) continue;
            int dx = abs(num / 3 - i);
            int dy = abs(num % 3 - j);
            h += dx + dy;
        }
    }
    return h;
}

void PutPath(int i) {
    while (path[i].next != -1) {
        putchar(dir[path[i].dir]);
        i = path[i].next;
    }
    putchar('\n');
}

int DFS(int node, int index, int dir, int g) {
    if (node == 0) return g;

    string s = RevHash(node);
    if (g + H(s) > minAns) return INF;

    for (int i = 0; i < 4; ++i) {
        if (abs(i - dir) == 2) continue;
        int nx = index / 3 + dirx[i];
        int ny = index % 3 + diry[i];
        if (!InRange(nx, ny)) continue;

        int nIndex = nx * 3 + ny;
        swap(s[index], s[nIndex]);
        int nNode = Hash(s);

        int temp = DFS(nNode, nIndex, i, g + 1);
        if (temp != INF) {
            path[node] = Path(i, nNode);
            return temp;
        }
        swap(s[index], s[nIndex]);
    }
    return INF;
}

void IDAStar(string s) {
    path[0] = Path(0, -1);
    minAns = H(s);
    while (DFS(Hash(s), IndexOfX(s), 0, 0) == INF) ++minAns;
    PutPath(Hash(s));
}

int main() {
#ifdef NIGHT_13
    freopen("in.txt", "r", stdin);
#endif
    for (int i = 1; i < 10; ++i) {
        jie[i] = jie[i - 1] * i;
    }

    char s[100];
    while (gets_s(s) != NULL) {
        string ma = Tidy(s);
        int rev = 0;

        for (int i = 0; i < 9; ++i) {
            if (ma[i] == '9') continue;
            for (int j = i + 1; j < 9; ++j) {
                if (ma[i] > ma[j]) ++rev;
            }
        }
        if (rev & 1) puts("unsolvable");
        else IDAStar(ma);
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
这是一道比较经典的计数问题。题目描述如下: 给定一个 $n \times n$ 的网格图,其中一些格子被标记为障碍。一个连通块是指一些被标记为障碍的格子的集合,满足这些格子在网格图中连通。一个格子是连通的当且仅当它与另一个被标记为障碍的格子在网格图中有公共边。 现在,你需要计算在这个网格图中,有多少个不同的连通块,满足这个连通块的大小(即包含的格子数)恰好为 $k$。 这是一道比较经典的计数问题,一般可以通过计算生成函数的方法来解决。具体来说,我们可以定义一个生成函数 $F(x)$,其中 $[x^k]F(x)$ 表示大小为 $k$ 的连通块的个数。那么,我们可以考虑如何计算这个生成函数。 对于一个大小为 $k$ 的连通块,我们可以考虑它的形状。具体来说,我们可以考虑以该连通块的最左边、最上边的格子为起点,从上到下、从左到右遍历该连通块,把每个格子在该连通块中的相对位置记录下来。由于该连通块的大小为 $k$,因此这些相对位置一定是 $(x,y) \in [0,n-1]^2$ 中的 $k$ 个不同点。 现在,我们需要考虑如何计算这些点对应的连通块是否合法。具体来说,我们可以考虑从左到右、从上到下依次处理这些点,对于每个点 $(x,y)$,我们需要考虑它是否能够与左边的点和上边的点连通。具体来说,如果 $(x-1,y)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们就是连通的;同样,如果 $(x,y-1)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们也是连通的。如果 $(x,y)$ 与左边和上边的点都不连通,那么说明这个点不属于该连通块。 考虑到每个点最多只有两个方向需要检查,因此时间复杂度为 $O(n^2 k)$。不过,我们可以使用类似于矩阵乘法的思想,将这个过程优化到 $O(k^3)$ 的时间复杂度。 具体来说,我们可以设 $f_{i,j,k}$ 表示状态 $(i,j)$ 所代表的点在连通块中,且连通块的大小为 $k$ 的方案数。显然,对于一个合法的 $(i,j,k)$,我们可以考虑 $(i-1,j,k-1)$ 和 $(i,j-1,k-1)$ 这两个状态,然后把点 $(i,j)$ 加入到它们所代表的连通块中。因此,我们可以设计一个 $O(k^3)$ 的 DP 状态转移,计算 $f_{i,j,k}$。 具体来说,我们可以考虑枚举连通块所包含的最右边和最下边的格子的坐标 $(x,y)$,然后计算 $f_{x,y,k}$。对于一个合法的 $(x,y,k)$,我们可以考虑将 $(x,y)$ 所代表的点加入到 $(x-1,y,k-1)$ 和 $(x,y-1,k-1)$ 所代表的连通块中。不过,这里需要注意一个细节:如果 $(x-1,y)$ 和 $(x,y)$ 在网格图中没有相邻边,那么它们不能算作连通的。因此,我们需要特判这个情况。 最终,$f_{n,n,k}$ 就是大小为 $k$ 的连通块的个数,时间复杂度为 $O(n^2 k + k^3)$。 参考代码:

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值